#ifdef OPENGL_ES
precision highp float;
#endif

// Uniforms
uniform sampler2D u_diffuseTexture;		// Diffuse map texture

varying vec3 o_vNml;
varying vec2 o_vUV;				// Texture coordinate
varying vec4 o_vFog;

// fog
const float fNear = 0.0;
const float fFar = 16.0;

void main()
{
	vec4 C = texture2D(u_diffuseTexture, o_vUV);
	float A = C.w;

	C = mix(vec4(0.1, 0.1, 0.1, 1.0), vec4(C.xyz, A), o_vFog);

// fog
	//float F0 = distance(o_vPos.xyz, o_vCamPos.xyz);
	float F0 = gl_FragCoord.z / gl_FragCoord.w;
	float F1 = (fFar - F0) / (fFar - fNear);
	F1 = clamp(F1, 0.0, 1.0);
	C = C * F1 + vec4(0.1, 0.1, 0.1, 1.0) * (1.0 - F1);

	gl_FragColor = vec4(C.xyz, A);
}
