// Attributes
attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord;

// Uniforms
uniform mat4 u_worldViewProjectionMatrix;

// Varyings
varying vec3 o_vNml;
varying vec2 o_vUV;
varying vec4 o_vFog;

// fog
const float fNear = 0.0;
const float fFar = 0.9;

void main()
{
	o_vFog = fNear + a_position.y * fFar;

	o_vNml = a_normal;
	o_vUV = a_texCoord;
	gl_Position = u_worldViewProjectionMatrix * a_position;
}
