#ifdef OPENGL_ES
precision highp float;
#endif

uniform sampler2D u_diffuseTexture;

varying vec3 o_vNml;
varying vec2 o_vUV;

// lightdir
const vec3 vLight = vec3(0.5, 2.5, 0.5);

// fog
const float fNear = 0.0;
const float fFar = 16.0;

void main()
{
	vec3 N = normalize(o_vNml);
	vec3 L = normalize(vLight);
	float F = dot(N, L);

	F = F * 0.5 + 0.5;
	F = F * F;
	F = F + 0.5;

	vec4 C = F * texture2D(u_diffuseTexture, o_vUV);
	float A = C.w;

// fog
	float F0 = gl_FragCoord.z / gl_FragCoord.w;
	float F1 = (fFar - F0) / (fFar - fNear);
	F1 = clamp(F1, 0.0, 1.0);
	C = C * F1 + vec4(0.1, 0.1, 0.1, 1.0) * (1.0 - F1);

	gl_FragColor = vec4(C.xyz, A);
}
