#ifdef OPENGL_ES
precision highp float;
#endif

// Uniforms
uniform sampler2D u_diffuseTexture;		// Diffuse map texture

// Varyings
varying vec2 o_vUV;				// Texture coordinate

// fog
const float fNear = 0.0;
const float fFar = 16.0;

void main()
{
//	vec4 C = texture2D(u_diffuseTexture, o_vUV);
//	float A = C.w;

	float depth = gl_FragCoord.z / gl_FragCoord.w;
	float sampleOffset = depth / 100000.0;

	vec4 col = vec4(0.0);
	col += texture2D(u_diffuseTexture, o_vUV.st + vec2(-sampleOffset,-sampleOffset)) * 1.0;
	col += texture2D(u_diffuseTexture, o_vUV.st + vec2( 0.0         ,-sampleOffset)) * 2.0;
	col += texture2D(u_diffuseTexture, o_vUV.st + vec2( sampleOffset,-sampleOffset)) * 1.0;

	col += texture2D(u_diffuseTexture, o_vUV.st + vec2(-sampleOffset, 0.0     )) * 2.0;
	col += texture2D(u_diffuseTexture, o_vUV.st + vec2( 0.0         , 0.0     )) * 4.0;
	col += texture2D(u_diffuseTexture, o_vUV.st + vec2( sampleOffset, 0.0     )) * 2.0;

	col += texture2D(u_diffuseTexture, o_vUV.st + vec2( sampleOffset, sampleOffset)) * 1.0;
	col += texture2D(u_diffuseTexture, o_vUV.st + vec2( 0.0         , sampleOffset)) * 2.0;
	col += texture2D(u_diffuseTexture, o_vUV.st + vec2(-sampleOffset, sampleOffset)) * 1.0;

	col /= 16.0;

	vec4 C = col;
	float A = C.w;

// fog
	//float F0 = distance(o_vPos.xyz, o_vCamPos.xyz);
	float F0 = gl_FragCoord.z / gl_FragCoord.w;
	float F1 = (fFar - F0) / (fFar - fNear);
	F1 = clamp(F1, 0.0, 1.0);
	C = C * F1 + vec4(0.1, 0.1, 0.1, 1.0) * (1.0 - F1);

	gl_FragColor = vec4(C.xyz, A);
}
