// Attributes
attribute vec4 a_position;		// Vertex position(x, y, z, w)
attribute vec2 a_texCoord;		// Vertex texture coordinate(u, v)

// Uniforms
uniform mat4 u_worldViewProjectionMatrix;			// Matrix to transform a position to clip space

// Varyings
varying vec2 o_vUV;						// Texture coordinate

void main()
{
	// Texture transformation
	o_vUV = a_texCoord;

	// Transform position to clip space.
	gl_Position = u_worldViewProjectionMatrix * a_position;
}
